-- format.applescript
-- iGP32

--  Created by Kounch on Tue Jul 13 2004.
--  Copyright (c) 2003 Kounch. All rights reserved.

-- This file is part of iGP32.
-- 
--  iGP32 is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  iGP32 is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with iGP32; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--Event received when the user clicks on format button of main window

global mainWindow
global progressPanel
global maclinkPath
global USBDelay

on clicked theObject
	--Load external library of functions
	try
		set scriptpath to ((path to me) & "Contents:Resources:Scripts:maclink.scpt") as string
		set maclinkLib to (load script file scriptpath)
		initLib() of maclinkLib
	on error errTexto
		--Normally an error means that other proccess is using the maclinklib, so we beep and return
		beep
		log errTexto
		return
	end try
	
	--Define warning dialog
	set confirmText to localized string "CONFIRM_KEY" from table "Localized"
	set formatText to localized string "ASK_FORMAT_KEY" from table "Localized"
	set okText to localized string "OK_KEY" from table "Localized"
	set cancelText to localized string "CANCEL_KEY" from table "Localized"
	--Show warning dialog
	set withResult to display alert confirmText as warning message formatText default button cancelText alternate button okText
	
	--Check if the user has decided to format SMC
	if button returned of withResult is equal to okText then
		--display progress panel
		tell progressPanel
			set contents of text field "filename" to " "
			set actionText to localized string "FORMAT_KEY" from table "Localized"
			set contents of text field "action" to actionText
			start progress indicator "progress"
		end tell
		display progressPanel attached to mainWindow
		
		--Try to format SMC in GP32
		try
			set theResult to ""
			set theResult to do shell script maclinkPath & " format"
			
			--Create GP32 standard directory structure
			set theResult to do shell script maclinkPath & " mkdir /GAME"
			set theResult to do shell script maclinkPath & " mkdir /MP3"
			set theResult to do shell script maclinkPath & " mkdir /GPSYS"
			set theResult to do shell script maclinkPath & " mkdir /GPMM"
			set theResult to do shell script maclinkPath & " mkdir /GPETC"
			set theResult to do shell script maclinkPath & " mkdir -x /MOVIE"
			
			--close panel
			close panel (progressPanel)
			
		on error errText number errNumber
			log "maklink format or mkdir Error: " & theResult
			--close panel
			close panel (progressPanel)
			--If we get in here, there has been some problem with USB connection
			USBError() of maclinkLib
		end try
	end if
end clicked


