-- iGP32.applescript
-- iGP32

--  Created by Kounch on Tue Jul 13 2004.
--  Copyright (c) 2003 Kounch. All rights reserved.

-- This file is part of iGP32.
-- 
--  iGP32 is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  iGP32 is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with iGP32; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

global mainWindow
global progressPanel
global maclinkPath
global maclinkLib
global USBDelay
global fatalError
global debugMode

global PackageAction
global ExecutableAction

--We want the application to quit if all windows are closed
on should quit after last window closed theObject
	true
end should quit after last window closed

--Save Window position each time it is moved
on moved theObject
	--Get window coordinates
	set {windowX, windowY} to position of theObject
	--Save coordinates to defaults
	set contents of default entry "defaultMainWindowX" of user defaults to windowX
	set contents of default entry "defaultMainWindowY" of user defaults to windowY
end moved

on will open theObject
	--Load external library of functions
	try
		set scriptpath to ((path to me) & "Contents:Resources:Scripts:maclink.scpt") as string
		set maclinkLib to (load script file scriptpath)
		--Initialize external library
		initLib() of maclinkLib
	on error errTexto
		--Normally an error means that other proccess is using the maclinklib, so we beep and return
		beep
		log errTexto
		return
	end try
	
	--Create defaults if they don't exist yet
	try
		--Debug flag
		make new default entry at end of default entries of user defaults with properties {name:"debug", contents:"No"}
		--Main window coordinates
		make new default entry at end of default entries of user defaults with properties {name:"defaultMainWindowX", contents:"Testing"}
		make new default entry at end of default entries of user defaults with properties {name:"defaultMainWindowY", contents:"Testing"}
		--Browser window coordinates
		make new default entry at end of default entries of user defaults with properties {name:"defaultBrowserWindowX", contents:"Testing"}
		make new default entry at end of default entries of user defaults with properties {name:"defaultBrowserWindowY", contents:"Testing"}
		--Encoder window coordinates
		make new default entry at end of default entries of user defaults with properties {name:"defaultEncoderWindowX", contents:"Testing"}
		make new default entry at end of default entries of user defaults with properties {name:"defaultEncoderWindowY", contents:"Testing"}
		--Information window coordinates
		make new default entry at end of default entries of user defaults with properties {name:"defaultInfoWindowX", contents:"Testing"}
		make new default entry at end of default entries of user defaults with properties {name:"defaultInfoWindowY", contents:"Testing"}
		
		--Get debug status
		set debugMode to contents of default entry "debug" of user defaults
		
		--Get window position from defaults
		set windowX to contents of default entry "defaultMainWindowX" of user defaults
		set windowY to contents of default entry "defaultMainWindowY" of user defaults
		--Set window position if it's been saved at least once
		if windowX  "Testing" and windowY  "Testing" then
			set position of window "main" to {windowX, windowY}
		end if
	on error errTexto
		log errTexto
	end try
end will open

on open theObject
	delay 2 --Let some time to the app to initialize
	
	--Install Packages default action
	make new default entry at end of default entries of user defaults with properties {name:"defaultPackageAction", contents:"Nothing"}
	set PackageAction to contents of default entry "defaultPackageAction" of user defaults
	
	--Executables default action
	make new default entry at end of default entries of user defaults with properties {name:"defaultExecutableAction", contents:"Nothing"}
	set ExecutableAction to contents of default entry "defaultExecutableAction" of user defaults
	
	proccessFiles(theObject) of maclinkLib
end open

on clicked theObject
	(*Add your script here.*)
end clicked
