-- info.applescript
-- iGP32

--  Created by Kounch on Tue Jul 13 2004.
--  Copyright (c) 2003 Kounch. All rights reserved.

-- This file is part of iGP32.
-- 
--  iGP32 is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  iGP32 is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with iGP32; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

global maclinkPath --Variable defined in maclinkLib

--Event received when clicking on the info button of main window
on clicked theObject
	--Load external library of functions
	try
		set scriptpath to ((path to me) & "Contents:Resources:Scripts:maclink.scpt") as string
		set maclinkLib to (load script file scriptpath)
		--Initialize external library
		initLib() of maclinkLib
	on error errTexto
		--Normally an error means that other proccess is using the maclinklib, so we beep and return
		beep
		log errTexto
		return
	end try
	
	--Define info window
	set infoWindow to "info"
	
	try
		set theResult to ""
		--try to connect to gp32 device and obtain data
		set theResult to do shell script maclinkPath & " info"
		
		--Show information window
		show window infoWindow
		--Show data in information window
		tell window infoWindow
			set contents of text field "gp32guid" to (get word 4 of paragraph 3 of theResult)
			set contents of text field "smcguid" to (get word 4 of paragraph 4 of theResult)
			set contents of text field "user" to (get word 2 of paragraph 5 of theResult)
			set contents of text field "password" to "******"
			set contents of text field "fwVersion" to (get word 3 of paragraph 7 of theResult)
			set contents of text field "fwBuild" to (get word 8 of paragraph 7 of theResult)
			set contents of text field "fwDate" to (get word 10 of paragraph 7 of theResult)
			set contents of text field "smcsize" to (get word 4 of paragraph 8 of theResult)
			set contents of text field "smcused" to (get word 6 of paragraph 8 of theResult)
			set contents of text field "smcfree" to (get word 8 of paragraph 8 of theResult)
			update
		end tell
	on error errText number errNumber
		log "maclink info Error: " & theResult
		--if an error was found, inform the user
		USBError() of maclinkLib
		--close info window as the data in the info window may be missing or incomplete
		hide window infoWindow
	end try
end clicked

--event received before opening the info window
on will open theObject
	--Get window position from defaults
	set windowX to contents of default entry "defaultInfoWindowX" of user defaults
	set windowY to contents of default entry "defaultInfoWindowY" of user defaults
	--Set window position if it's been saved at least once
	if windowX  "Testing" and windowY  "Testing" then
		set position of window "info" to {windowX, windowY}
	end if
	
	--Clear text fields before opening window
	tell theObject
		set contents of text field "fwVersion" to " "
		set contents of text field "fwBuild" to ""
		set contents of text field "fwDate" to ""
		set contents of text field "gp32guid" to ""
		set contents of text field "smcguid" to ""
		set contents of text field "user" to ""
		set contents of text field "password" to ""
		set contents of text field "smcsize" to ""
		set contents of text field "smcused" to ""
		set contents of text field "smcfree" to ""
	end tell
end will open

on moved theObject
	--Get window coordinates
	set {windowX, windowY} to position of theObject
	--Save coordinates to defaults
	set contents of default entry "defaultInfoWindowX" of user defaults to windowX
	set contents of default entry "defaultInfoWindowY" of user defaults to windowY
end moved