-- install.applescript
-- iGP32

--  Created by Kounch on Tue Jul 13 2004.
--  Copyright (c) 2003 Kounch. All rights reserved.

-- This file is part of iGP32.
-- 
--  iGP32 is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  iGP32 is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with iGP32; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

global PackageAction

--Event received when the user clicks on install button of main window
on clicked theObject
	--Load external library of functions
	try
		set scriptpath to ((path to me) & "Contents:Resources:Scripts:maclink.scpt") as string
		set maclinkLib to (load script file scriptpath)
		--Initialize external library
		initLib() of maclinkLib
	on error errTexto
		--Normally an error means that other proccess is using the maclinklib, so we beep and return
		beep
		log errTexto
		return
	end try
	
	--Define open panel
	set can choose directories of open panel to false
	set can choose files of open panel to true
	set selectTitle to localized string "INSTALL_TITLE_KEY" from table "Localized"
	set title of open panel to selectTitle
	set installButton to localized string "INSTALL_BUTTON_KEY" from table "Localized"
	set prompt of open panel to installButton
	--show open panel
	set withResult to display open panel for file types {"fpk", "zpk"}
	
	--Check if user has selected a file
	if withResult is 1 then
		--Get file path
		set installFile to (POSIX file (path names of open panel) as list)
		--Install the file
		set PackageAction to "InstallAll"
		proccessFiles(installFile) of maclinkLib
	end if
end clicked

